#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <stdlib.h>
#include <portbits.h>
#include "global.h"
#include "uart.h"
#include "rf22.h"
#include <util/delay.h>

#define RF_BAUDRATE		25000		// Baudrate des RFM12 (Datenrate in kByte=Baudrate/16)
#define UART_BAUDRATE	19200

unsigned char data[64], rssi;

int main(void)
{	PORTD=254;
	DDRD=254;
	DDRC=255;

	unsigned c, i;

    uart_init(UART_BAUD_SELECT(UART_BAUDRATE, F_CPU));
	rf22_init();
	rf22_setfreq(RF22FREQ(433.92));
	rf22_setbaud(RF22BAUD(20000));
	rf22_setrxpara(PARA_20000_WIDE);

	uart_puts_P("\nRevision: ");
	c=rf22_read(0x01);	// chip revision
	uart_putc((c/10)%10+48);
	uart_putc((c/1)%10+48);

	sei();
/*
	for (;;)					// Datenpaket von UART senden
	{	for (i=0; i<64; i++)
		{	if (!uart_data())
			{	_delay_ms(100);
				if (!uart_data())
					break;
			}
			data[i]=uart_getchar();
		}
		if (i)
		{	rf22_sendpacket(data,i);
		}
	}
*/

	rf22_rxmode();				// Datenpakete empfangen
	for (;;)
	{	if(rf22_read(0x31)&16)		// receiving a packet
			rssi=rf22_read(0x26);	// rssi
		if ((rf22_read(0x03)&2)&&(!(rf22_read(0x02)&32)))	// packet received & not read
		{	c=rf22_read(0x4B);	// packet length
			uart_puts_P("\nSize: ");
			uart_putc(c/100+48);
			uart_putc((c/10)%10+48);
			uart_putc((c/1)%10+48);

			uart_puts_P(" RSSI: -");
			rssi=245-rssi;
			uart_putc(rssi/200+48);
			uart_putc((rssi/20)%10+48);
			uart_putc((rssi/2)%10+48);
			uart_putc('.');
			uart_putc((rssi&1)*5+48);
			uart_puts_P("dBm Data: ");

			for (i=0; i<c+5; i++)
				uart_putc(rf22_read(0x7f));
			
		}
	}

}


